#include <set>
#include <iostream>
#include <vector>

#define inf 1000000000
using namespace std;

class mCmp {
	public:
		bool operator()(int a, int b);
};

typedef set<int, mCmp> S;
typedef S::iterator SI;
typedef S::const_iterator SCI;
class V
{
	public:
		int dist;
		bool v;
		SI it;
		vector<pair<int, int> > e;
};

V v[1000];

bool mCmp::operator()(int a, int b) {
	return v[a].dist != v[b].dist ? v[a].dist < v[b].dist : a < b;
}

S s;

int main() {
	int n, m; cin >> n >> m;
	for (int i = 0; i < m; ++i) {
		int u, z, w; cin >> u >> z >> w;
		v[u].e.push_back(make_pair(z, w));
	}

	for (int i = 0; i < n; ++i) v[i].dist = inf;
	v[0].dist = 0;
	v[0].v = true;
	for (int i = 0; i < n; ++i) v[i].it = s.insert(i).first;
	
	while (s.size()) {
		SI _cur = s.begin();
		int cur = *_cur;
		s.erase(_cur);
		v[cur].v = true;
		for (vector<pair<int, int> >::iterator i = v[cur].e.begin(); i != v[cur].e.end(); ++i) {
			if (!v[i->first].v && v[i->first].dist > v[cur].dist + i->second) {
				s.erase(v[i->first].it);
				v[i->first].dist = v[cur].dist + i->second;
				v[i->first].it = s.insert(i->first).first;
			}
		}
	}
	for (int i = 0; i < n; ++i)
	{
		cout << v[i].dist << endl;
	}
}
