#!/bin/bash

ok=0

for ((i=0; i<$1; ++i)); do
	./gen_test $(($RANDOM * $RANDOM)) > task.in
	./main < task.in > task.out
	./corr < task.in > task.corr
	export ok=$(($ok + 1))
	./check task.in task.out task.corr
#	diff task.out task.corr > /dev/null
	if [ "$?" != "0" ]; then
		echo "Failed test #$ok"
		exit 1
	fi
done
echo "OK"
